--- net/minecraft/src/NetHandler.java
+++ net/minecraft/src/NetHandler.java
@@ -1,13 +1,15 @@
 package net.minecraft.src;
 
-public class NetHandler {
+public abstract class NetHandler {
+	public abstract boolean isServerHandler();
+
 	public void handleMapChunk(Packet51MapChunk var1) {
 	}
 
 	public void registerPacket(Packet var1) {
 	}
 
-	public void handleErrorMessage(String var1) {
+	public void handleErrorMessage(String var1, Object[] var2) {
 	}
 
 	public void handleKickDisconnect(Packet255KickDisconnect var1) {
@@ -74,15 +76,15 @@
 		this.registerPacket(var1);
 	}
 
-	public void handleAddToInventory(Packet17AddToInventory var1) {
-		this.registerPacket(var1);
-	}
-
 	public void handleVehicleSpawn(Packet23VehicleSpawn var1) {
 		this.registerPacket(var1);
 	}
 
-	public void handleArmAnimation(Packet18ArmAnimation var1) {
+	public void handleArmAnimation(Packet18Animation var1) {
+		this.registerPacket(var1);
+	}
+
+	public void func_21147_a(Packet19EntityAction var1) {
 		this.registerPacket(var1);
 	}
 
@@ -98,15 +100,123 @@
 		this.registerPacket(var1);
 	}
 
-	public void handlePlayerInventory(Packet5PlayerInventory var1) {
-		this.registerPacket(var1);
-	}
-
-	public void handleComplexEntity(Packet59ComplexEntity var1) {
-		this.registerPacket(var1);
-	}
-
 	public void handleSpawnPosition(Packet6SpawnPosition var1) {
 		this.registerPacket(var1);
+	}
+
+	public void func_6498_a(Packet28EntityVelocity var1) {
+		this.registerPacket(var1);
+	}
+
+	public void func_21148_a(Packet40EntityMetadata var1) {
+		this.registerPacket(var1);
+	}
+
+	public void func_6497_a(Packet39AttachEntity var1) {
+		this.registerPacket(var1);
+	}
+
+	public void handleUseEntity(Packet7UseEntity var1) {
+		this.registerPacket(var1);
+	}
+
+	public void func_9447_a(Packet38EntityStatus var1) {
+		this.registerPacket(var1);
+	}
+
+	public void handleHealth(Packet8UpdateHealth var1) {
+		this.registerPacket(var1);
+	}
+
+	public void func_9448_a(Packet9Respawn var1) {
+		this.registerPacket(var1);
+	}
+
+	public void func_12245_a(Packet60Explosion var1) {
+		this.registerPacket(var1);
+	}
+
+	public void func_20087_a(Packet100OpenWindow var1) {
+		this.registerPacket(var1);
+	}
+
+	public void func_20092_a(Packet101CloseWindow var1) {
+		this.registerPacket(var1);
+	}
+
+	public void func_20091_a(Packet102WindowClick var1) {
+		this.registerPacket(var1);
+	}
+
+	public void func_20088_a(Packet103SetSlot var1) {
+		this.registerPacket(var1);
+	}
+
+	public void func_20094_a(Packet104WindowItems var1) {
+		this.registerPacket(var1);
+	}
+
+	public void handleSignUpdate(Packet130UpdateSign var1) {
+		this.registerPacket(var1);
+	}
+
+	public void func_20090_a(Packet105UpdateProgressbar var1) {
+		this.registerPacket(var1);
+	}
+
+	public void handlePlayerInventory(Packet5PlayerInventory var1) {
+		this.registerPacket(var1);
+	}
+
+	public void func_20089_a(Packet106Transaction var1) {
+		this.registerPacket(var1);
+	}
+
+	public void func_21146_a(Packet25EntityPainting var1) {
+		this.registerPacket(var1);
+	}
+
+	public void handleNotePlay(Packet54PlayNoteBlock var1) {
+		this.registerPacket(var1);
+	}
+
+	public void func_27245_a(Packet200Statistic var1) {
+		this.registerPacket(var1);
+	}
+
+	public void func_22186_a(Packet17Sleep var1) {
+		this.registerPacket(var1);
+	}
+
+	public void func_22185_a(Packet27Position var1) {
+		this.registerPacket(var1);
+	}
+
+	public void func_25118_a(Packet70Bed var1) {
+		this.registerPacket(var1);
+	}
+
+	public void handleWeather(Packet71Weather var1) {
+		this.registerPacket(var1);
+	}
+
+	public void func_28116_a(Packet131MapData var1) {
+		this.registerPacket(var1);
+	}
+
+	public void func_28115_a(Packet61DoorChange var1) {
+		this.registerPacket(var1);
+	}
+	
+	public void handle62Sound(Packet62Sound var1) {
+		this.registerPacket(var1);
+	}
+	
+	public void handle55BlockBreakAnimation(Packet55BlockBreakAnimation p) {
+		this.registerPacket(p);
+	}
+
+	public void handleParticle(Packet63WorldParticles packet) {
+		this.registerPacket(packet);
 	}
 }
--- net/minecraft/src/ItemSnowball.java
+++ net/minecraft/src/ItemSnowball.java
@@ -9,7 +9,9 @@
 	public ItemStack onItemRightClick(ItemStack var1, World var2, EntityPlayer var3) {
 		--var1.stackSize;
 		var2.playSoundAtEntity(var3, "random.bow", 0.5F, 0.4F / (rand.nextFloat() * 0.4F + 0.8F));
-		var2.spawnEntityInWorld(new EntitySnowball(var2, var3));
+		if(!var2.multiplayerWorld) {
+			var2.spawnEntityInWorld(new EntitySnowball(var2, var3));
+		}
 		return var1;
 	}
 }
--- /dev/null
+++ net/minecraft/src/Packet40EntityMetadata.java
@@ -1,0 +1,33 @@
+package net.minecraft.src;
+
+import java.io.DataInputStream;
+import java.io.DataOutputStream;
+import java.io.IOException;
+import java.util.List;
+
+public class Packet40EntityMetadata extends Packet {
+	public int entityId;
+	private List field_21048_b;
+
+	public void readPacketData(DataInputStream var1) throws IOException {
+		this.entityId = var1.readInt();
+		this.field_21048_b = DataWatcher.readWatchableObjects(var1);
+	}
+
+	public void writePacketData(DataOutputStream var1) throws IOException {
+		var1.writeInt(this.entityId);
+		DataWatcher.writeObjectsInListToStream(this.field_21048_b, var1);
+	}
+
+	public void processPacket(NetHandler var1) {
+		var1.func_21148_a(this);
+	}
+
+	public int getPacketSize() {
+		return 5;
+	}
+
+	public List func_21047_b() {
+		return this.field_21048_b;
+	}
+}
--- net/minecraft/src/ItemBoat.java
+++ net/minecraft/src/ItemBoat.java
@@ -30,7 +30,9 @@
 				int var25 = var24.blockX;
 				int var26 = var24.blockY;
 				int var27 = var24.blockZ;
-				var2.spawnEntityInWorld(new EntityBoat(var2, (double)((float)var25 + 0.5F), (double)((float)var26 + 1.5F), (double)((float)var27 + 0.5F)));
+				if(!var2.multiplayerWorld) {
+					var2.spawnEntityInWorld(new EntityBoat(var2, (double)((float)var25 + 0.5F), (double)((float)var26 + 1.5F), (double)((float)var27 + 0.5F)));
+				}
 				--var1.stackSize;
 			}
 
--- net/minecraft/src/InventoryLargeChest.java
+++ net/minecraft/src/InventoryLargeChest.java
@@ -44,4 +44,8 @@
 		this.upperChest.onInventoryChanged();
 		this.lowerChest.onInventoryChanged();
 	}
+
+	public boolean canInteractWith(EntityPlayer var1) {
+		return this.upperChest.canInteractWith(var1) && this.lowerChest.canInteractWith(var1);
+	}
 }
--- net/minecraft/src/NetworkWriterThread.java
+++ net/minecraft/src/NetworkWriterThread.java
@@ -1,5 +1,7 @@
 package net.minecraft.src;
 
+import java.io.IOException;
+
 class NetworkWriterThread extends Thread {
 	final NetworkManager netManager;
 
@@ -15,18 +17,36 @@
 		}
 
 		while(true) {
-			boolean var11 = false;
+			boolean var13 = false;
 
 			try {
-				var11 = true;
+				var13 = true;
 				if(!NetworkManager.isRunning(this.netManager)) {
-					var11 = false;
+					var13 = false;
 					break;
 				}
 
-				NetworkManager.sendNetworkPacket(this.netManager);
+				while(NetworkManager.sendNetworkPacket(this.netManager)) {
+				}
+
+				try {
+					sleep(2L);
+				} catch (InterruptedException var16) {
+				}
+
+				try {
+					if(NetworkManager.func_28140_f(this.netManager) != null) {
+						NetworkManager.func_28140_f(this.netManager).flush();
+					}
+				} catch (IOException var18) {
+					if(!NetworkManager.func_28138_e(this.netManager)) {
+						NetworkManager.func_30005_a(this.netManager, var18);
+					}
+
+					var18.printStackTrace();
+				}
 			} finally {
-				if(var11) {
+				if(var13) {
 					Object var5 = NetworkManager.threadSyncObject;
 					synchronized(var5) {
 						--NetworkManager.numWriteThreads;
--- net/minecraft/src/Packet2Handshake.java
+++ net/minecraft/src/Packet2Handshake.java
@@ -15,11 +15,11 @@
 	}
 
 	public void readPacketData(DataInputStream var1) throws IOException {
-		this.username = var1.readUTF();
+		this.username = readString(var1, 32);
 	}
 
-	public void writePacket(DataOutputStream var1) throws IOException {
-		var1.writeUTF(this.username);
+	public void writePacketData(DataOutputStream var1) throws IOException {
+		writeString(this.username, var1);
 	}
 
 	public void processPacket(NetHandler var1) {
--- net/minecraft/src/RenderTNTPrimed.java
+++ net/minecraft/src/RenderTNTPrimed.java
@@ -31,14 +31,14 @@
 
 		var10 = (1.0F - ((float)var1.fuse - var9 + 1.0F) / 100.0F) * 0.8F;
 		this.loadTexture("/terrain.png");
-		this.blockRenderer.renderBlockOnInventory(Block.tnt);
+		this.blockRenderer.renderBlockOnInventory(Block.tnt, 0);
 		if(var1.fuse / 5 % 2 == 0) {
 			GL11.glDisable(GL11.GL_TEXTURE_2D);
 			GL11.glDisable(GL11.GL_LIGHTING);
 			GL11.glEnable(GL11.GL_BLEND);
 			GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_DST_ALPHA);
 			GL11.glColor4f(1.0F, 1.0F, 1.0F, var10);
-			this.blockRenderer.renderBlockOnInventory(Block.tnt);
+			this.blockRenderer.renderBlockOnInventory(Block.tnt, 0);
 			GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
 			GL11.glDisable(GL11.GL_BLEND);
 			GL11.glEnable(GL11.GL_LIGHTING);
--- net/minecraft/src/Packet16BlockItemSwitch.java
+++ net/minecraft/src/Packet16BlockItemSwitch.java
@@ -5,24 +5,20 @@
 import java.io.IOException;
 
 public class Packet16BlockItemSwitch extends Packet {
-	public int entityId;
 	public int id;
 
 	public Packet16BlockItemSwitch() {
 	}
 
-	public Packet16BlockItemSwitch(int var1, int var2) {
-		this.entityId = var1;
-		this.id = var2;
+	public Packet16BlockItemSwitch(int var1) {
+		this.id = var1;
 	}
 
 	public void readPacketData(DataInputStream var1) throws IOException {
-		this.entityId = var1.readInt();
 		this.id = var1.readShort();
 	}
 
-	public void writePacket(DataOutputStream var1) throws IOException {
-		var1.writeInt(this.entityId);
+	public void writePacketData(DataOutputStream var1) throws IOException {
 		var1.writeShort(this.id);
 	}
 
@@ -31,6 +27,6 @@
 	}
 
 	public int getPacketSize() {
-		return 6;
+		return 2;
 	}
 }
--- net/minecraft/src/RenderSheep.java
+++ net/minecraft/src/RenderSheep.java
@@ -8,7 +8,7 @@
 
 	protected boolean renderFur(EntitySheep var1, int var2) {
 		this.loadTexture("/mob/sheep_fur.png");
-		return var2 == 0 && !var1.sheared;
+		return var2 == 0 && !var1.getSheared();
 	}
 
 	protected boolean shouldRenderPass(EntityLiving var1, int var2) {
--- net/minecraft/src/Packet30Entity.java
+++ net/minecraft/src/Packet30Entity.java
@@ -17,7 +17,7 @@
 		this.entityId = var1.readInt();
 	}
 
-	public void writePacket(DataOutputStream var1) throws IOException {
+	public void writePacketData(DataOutputStream var1) throws IOException {
 		var1.writeInt(this.entityId);
 	}
 
--- net/minecraft/src/Block.java
+++ net/minecraft/src/Block.java
@@ -54,7 +54,7 @@
 	public static final Block clothMagenta = null;
 	public static final Block clothRose = null;
 	public static final Block clothDarkGray = null;
-	public static final Block cloth = (new Block(35, 64, Material.cloth)).setHardness(0.8F).setStepSound(soundClothFootstep);
+	public static final Block cloth = (new BlockWool()).setHardness(0.8F).setStepSound(soundClothFootstep);
 	public static final Block clothWhite = null;
 	public static final BlockFlower plantYellow = (BlockFlower)(new BlockFlower(37, 13)).setHardness(0.0F).setStepSound(soundGrassFootstep);
 	public static final BlockFlower plantRed = (BlockFlower)(new BlockFlower(38, 12)).setHardness(0.0F).setStepSound(soundGrassFootstep);
@@ -295,7 +295,7 @@
 						double var11 = (double)(var1.rand.nextFloat() * var10) + (double)(1.0F - var10) * 0.5D;
 						double var13 = (double)(var1.rand.nextFloat() * var10) + (double)(1.0F - var10) * 0.5D;
 						double var15 = (double)(var1.rand.nextFloat() * var10) + (double)(1.0F - var10) * 0.5D;
-						EntityItem var17 = new EntityItem(var1, (double)var2 + var11, (double)var3 + var13, (double)var4 + var15, new ItemStack(var9));
+						EntityItem var17 = new EntityItem(var1, (double)var2 + var11, (double)var3 + var13, (double)var4 + var15, new ItemStack(var9, 1, this.damageDropped(var5)));
 						var17.delayBeforeCanPickup = 10;
 						var1.spawnEntityInWorld(var17);
 					}
@@ -472,10 +472,16 @@
 	public boolean canBlockStay(World var1, int var2, int var3, int var4) {
 		return true;
 	}
+	
+	protected int damageDropped(int var1) {
+		return 0;
+	}
 
 	static {
+		Item.itemsList[cloth.blockID] = new ItemWool(cloth.blockID - 256);
+		
 		for(int var0 = 0; var0 < 256; ++var0) {
-			if(blocksList[var0] != null) {
+			if(blocksList[var0] != null && Item.itemsList[var0] == null) {
 				Item.itemsList[var0] = new ItemBlock(var0 - 256);
 			}
 		}
--- net/minecraft/src/InventoryCraftResult.java
+++ net/minecraft/src/InventoryCraftResult.java
@@ -35,4 +35,8 @@
 
 	public void onInventoryChanged() {
 	}
+
+	public boolean canInteractWith(EntityPlayer var1) {
+		return true;
+	}
 }
--- net/minecraft/src/Packet20NamedEntitySpawn.java
+++ net/minecraft/src/Packet20NamedEntitySpawn.java
@@ -31,7 +31,7 @@
 
 	public void readPacketData(DataInputStream var1) throws IOException {
 		this.entityId = var1.readInt();
-		this.name = var1.readUTF();
+		this.name = readString(var1, 16);
 		this.xPosition = var1.readInt();
 		this.yPosition = var1.readInt();
 		this.zPosition = var1.readInt();
@@ -40,9 +40,9 @@
 		this.currentItem = var1.readShort();
 	}
 
-	public void writePacket(DataOutputStream var1) throws IOException {
+	public void writePacketData(DataOutputStream var1) throws IOException {
 		var1.writeInt(this.entityId);
-		var1.writeUTF(this.name);
+		writeString(this.name, var1);
 		var1.writeInt(this.xPosition);
 		var1.writeInt(this.yPosition);
 		var1.writeInt(this.zPosition);
--- net/minecraft/src/Item.java
+++ net/minecraft/src/Item.java
@@ -75,8 +75,8 @@
 	public static Item sign = (new ItemSign(67)).setIconIndex(42);
 	public static Item doorWood = (new ItemDoor(68, Material.wood)).setIconIndex(43);
 	public static Item bucketEmpty = (new ItemBucket(69, 0)).setIconIndex(74);
-	public static Item bucketWater = (new ItemBucket(70, Block.waterMoving.blockID)).setIconIndex(75);
-	public static Item bucketLava = (new ItemBucket(71, Block.lavaMoving.blockID)).setIconIndex(76);
+	public static Item bucketWater = (new ItemBucket(70, Block.waterMoving.blockID)).setIconIndex(75).setContainerItem(bucketEmpty);
+	public static Item bucketLava = (new ItemBucket(71, Block.lavaMoving.blockID)).setIconIndex(76).setContainerItem(bucketEmpty);
 	public static Item minecartEmpty = (new ItemMinecart(72, 0)).setIconIndex(135);
 	public static Item saddle = (new ItemSaddle(73)).setIconIndex(104);
 	public static Item doorSteel = (new ItemDoor(74, Material.iron)).setIconIndex(44);
@@ -84,7 +84,7 @@
 	public static Item snowball = (new ItemSnowball(76)).setIconIndex(14);
 	public static Item boat = (new ItemBoat(77)).setIconIndex(136);
 	public static Item leather = (new Item(78)).setIconIndex(103);
-	public static Item bucketMilk = (new ItemBucket(79, -1)).setIconIndex(77);
+	public static Item bucketMilk = (new ItemBucket(79, -1)).setIconIndex(77).setContainerItem(bucketEmpty);
 	public static Item brick = (new Item(80)).setIconIndex(22);
 	public static Item clay = (new Item(81)).setIconIndex(57);
 	public static Item reed = (new ItemReed(82, Block.reed)).setIconIndex(27);
@@ -103,6 +103,8 @@
 	protected int maxDamage = 32;
 	protected int iconIndex;
 	protected boolean bFull3D = false;
+	protected boolean hasSubtypes = false;
+	private Item containerItem = null;
 
 	protected Item(int var1) {
 		this.shiftedIndex = 256 + var1;
@@ -117,9 +119,18 @@
 		this.iconIndex = var1;
 		return this;
 	}
+	
+	public Item setMaxStackSize(int var1) {
+		this.maxStackSize = var1;
+		return this;
+	}
+	
+	public int getSprite(int metadata) {
+	      return this.iconIndex;
+	   }
 
 	public int getIconIndex(ItemStack var1) {
-		return this.iconIndex;
+		return this.getSprite(var1.getItemDamageForDisplay());
 	}
 
 	public boolean onItemUse(ItemStack var1, EntityPlayer var2, World var3, int var4, int var5, int var6, int var7) {
@@ -137,15 +148,37 @@
 	public int getItemStackLimit() {
 		return this.maxStackSize;
 	}
+	
+	public int getPlacedBlockMetadata(int var1) {
+		return 0;
+	}
+
+	public boolean getHasSubtypes() {
+		return this.hasSubtypes;
+	}
+
+	protected Item setHasSubtypes(boolean var1) {
+		this.hasSubtypes = var1;
+		return this;
+	}
 
 	public int getMaxDamage() {
 		return this.maxDamage;
 	}
-
-	public void hitEntity(ItemStack var1, EntityLiving var2) {
-	}
-
-	public void onBlockDestroyed(ItemStack var1, int var2, int var3, int var4, int var5) {
+	
+	protected Item setMaxDamage(int var1) {
+		this.maxDamage = var1;
+		return this;
+	}
+
+	public boolean isDamagable() {
+		return this.maxDamage > 0 && !this.hasSubtypes;
+	}
+
+	public void hitEntity(ItemStack var1, EntityLiving var2, EntityLiving var3) {
+	}
+
+	public void onBlockDestroyed(ItemStack var1, int var2, int var3, int var4, int var5, EntityLiving var6) {
 	}
 
 	public int getDamageVsEntity(Entity var1) {
@@ -166,5 +199,32 @@
 
 	public boolean isFull3D() {
 		return this.bFull3D;
+	}
+	
+	public boolean shouldRotateAroundWhenRendering() {
+		return false;
+	}
+	
+	public Item setContainerItem(Item var1) {
+		if(this.maxStackSize > 1) {
+			throw new IllegalArgumentException("Max stack size must be 1 for items with crafting results");
+		} else {
+			this.containerItem = var1;
+			return this;
+		}
+	}
+
+	public Item getContainerItem() {
+		return this.containerItem;
+	}
+	
+	public boolean hasContainerItem() {
+		return this.containerItem != null;
+	}
+	
+	public void onUpdate(ItemStack var1, World var2, Entity var3, int var4, boolean var5) {
+	}
+
+	public void onCreated(ItemStack var1, World var2, EntityPlayer var3) {
 	}
 }
--- net/minecraft/src/BlockRedstoneWire.java
+++ net/minecraft/src/BlockRedstoneWire.java
@@ -149,6 +149,9 @@
 
 	public void onBlockAdded(World var1, int var2, int var3, int var4) {
 		super.onBlockAdded(var1, var2, var3, var4);
+		if (var1.multiplayerWorld) {
+			return;
+		}
 		this.updateAndPropagateCurrentStrength(var1, var2, var3, var4);
 		var1.notifyBlocksOfNeighborChange(var2, var3 + 1, var4, this.blockID);
 		var1.notifyBlocksOfNeighborChange(var2, var3 - 1, var4, this.blockID);
@@ -184,6 +187,9 @@
 
 	public void onBlockRemoval(World var1, int var2, int var3, int var4) {
 		super.onBlockRemoval(var1, var2, var3, var4);
+		if (var1.multiplayerWorld) {
+			return;
+		}
 		var1.notifyBlocksOfNeighborChange(var2, var3 + 1, var4, this.blockID);
 		var1.notifyBlocksOfNeighborChange(var2, var3 - 1, var4, this.blockID);
 		this.updateAndPropagateCurrentStrength(var1, var2, var3, var4);
@@ -227,6 +233,9 @@
 	}
 
 	public void onNeighborBlockChange(World var1, int var2, int var3, int var4, int var5) {
+		if (var1.multiplayerWorld) {
+			return;
+		}
 		int var6 = var1.getBlockMetadata(var2, var3, var4);
 		boolean var7 = this.canPlaceBlockAt(var1, var2, var3, var4);
 		if(!var7) {
--- net/minecraft/src/Packet5PlayerInventory.java
+++ net/minecraft/src/Packet5PlayerInventory.java
@@ -5,52 +5,23 @@
 import java.io.IOException;
 
 public class Packet5PlayerInventory extends Packet {
-	public int inventoryType;
-	public ItemStack[] inventory;
-
-	public Packet5PlayerInventory() {
-	}
-
-	public Packet5PlayerInventory(int var1, ItemStack[] var2) {
-		this.inventoryType = var1;
-		this.inventory = new ItemStack[var2.length];
-
-		for(int var3 = 0; var3 < this.inventory.length; ++var3) {
-			this.inventory[var3] = var2[var3] == null ? null : var2[var3].copy();
-		}
-
-	}
+	public int entityID;
+	public int slot;
+	public int itemID;
+	public int itemDamage;
 
 	public void readPacketData(DataInputStream var1) throws IOException {
-		this.inventoryType = var1.readInt();
-		short var2 = var1.readShort();
-		this.inventory = new ItemStack[var2];
-
-		for(int var3 = 0; var3 < var2; ++var3) {
-			short var4 = var1.readShort();
-			if(var4 >= 0) {
-				byte var5 = var1.readByte();
-				short var6 = var1.readShort();
-				this.inventory[var3] = new ItemStack(var4, var5, var6);
-			}
-		}
-
+		this.entityID = var1.readInt();
+		this.slot = var1.readShort();
+		this.itemID = var1.readShort();
+		this.itemDamage = var1.readShort();
 	}
 
-	public void writePacket(DataOutputStream var1) throws IOException {
-		var1.writeInt(this.inventoryType);
-		var1.writeShort(this.inventory.length);
-
-		for(int var2 = 0; var2 < this.inventory.length; ++var2) {
-			if(this.inventory[var2] == null) {
-				var1.writeShort(-1);
-			} else {
-				var1.writeShort((short)this.inventory[var2].itemID);
-				var1.writeByte((byte)this.inventory[var2].stackSize);
-				var1.writeShort((short)this.inventory[var2].itemDmg);
-			}
-		}
-
+	public void writePacketData(DataOutputStream var1) throws IOException {
+		var1.writeInt(this.entityID);
+		var1.writeShort(this.slot);
+		var1.writeShort(this.itemID);
+		var1.writeShort(this.itemDamage);
 	}
 
 	public void processPacket(NetHandler var1) {
@@ -58,6 +29,6 @@
 	}
 
 	public int getPacketSize() {
-		return 6 + this.inventory.length * 5;
+		return 8;
 	}
 }
--- net/minecraft/src/GuiCrafting.java
+++ net/minecraft/src/GuiCrafting.java
@@ -3,34 +3,13 @@
 import org.lwjgl.opengl.GL11;
 
 public class GuiCrafting extends GuiContainer {
-	public CraftingInventoryWorkbenchCB craftingInventory = new CraftingInventoryWorkbenchCB();
-
-	public GuiCrafting(InventoryPlayer var1) {
-		this.inventorySlots.add(new SlotCrafting(this, this.craftingInventory.craftMatrix, this.craftingInventory.craftResult, 0, 124, 35));
-
-		int var2;
-		int var3;
-		for(var2 = 0; var2 < 3; ++var2) {
-			for(var3 = 0; var3 < 3; ++var3) {
-				this.inventorySlots.add(new SlotInventory(this, this.craftingInventory.craftMatrix, var3 + var2 * 3, 30 + var3 * 18, 17 + var2 * 18));
-			}
-		}
-
-		for(var2 = 0; var2 < 3; ++var2) {
-			for(var3 = 0; var3 < 9; ++var3) {
-				this.inventorySlots.add(new SlotInventory(this, var1, var3 + (var2 + 1) * 9, 8 + var3 * 18, 84 + var2 * 18));
-			}
-		}
-
-		for(var2 = 0; var2 < 9; ++var2) {
-			this.inventorySlots.add(new SlotInventory(this, var1, var2, 8 + var2 * 18, 142));
-		}
-
+	public GuiCrafting(InventoryPlayer var1, World var2, int var3, int var4, int var5) {
+		super(new ContainerWorkbench(var1, var2, var3, var4, var5));
 	}
 
 	public void onGuiClosed() {
 		super.onGuiClosed();
-		this.craftingInventory.onCraftGuiClosed(this.mc.thePlayer);
+		this.inventorySlots.onCraftGuiClosed(this.mc.thePlayer);
 	}
 
 	protected void drawGuiContainerForegroundLayer() {
--- net/minecraft/src/EntitySheep.java
+++ net/minecraft/src/EntitySheep.java
@@ -1,7 +1,6 @@
 package net.minecraft.src;
 
 public class EntitySheep extends EntityAnimal {
-	public boolean sheared = false;
 
 	public EntitySheep(World var1) {
 		super(var1);
@@ -9,9 +8,17 @@
 		this.setSize(0.9F, 1.3F);
 	}
 
+	protected void entityInit() {
+		super.entityInit();
+		this.dataWatcher.addObject(16, new Byte((byte)0));
+	}
+
 	public boolean attackEntityFrom(Entity var1, int var2) {
-		if(!this.sheared && var1 instanceof EntityLiving) {
-			this.sheared = true;
+		if(!this.getSheared() && var1 instanceof EntityLiving) {
+			if(this.worldObj.multiplayerWorld)
+				return false;
+			
+			this.setSheared(true);
 			int var3 = 1 + this.rand.nextInt(3);
 
 			for(int var4 = 0; var4 < var3; ++var4) {
@@ -27,12 +34,12 @@
 
 	public void writeEntityToNBT(NBTTagCompound var1) {
 		super.writeEntityToNBT(var1);
-		var1.setBoolean("Sheared", this.sheared);
+		var1.setBoolean("Sheared", this.getSheared());
 	}
 
 	public void readEntityFromNBT(NBTTagCompound var1) {
 		super.readEntityFromNBT(var1);
-		this.sheared = var1.getBoolean("Sheared");
+		this.setSheared(var1.getBoolean("Sheared"));
 	}
 
 	protected String getLivingSound() {
@@ -45,5 +52,19 @@
 
 	protected String getDeathSound() {
 		return "mob.sheep";
+	}
+	
+	public boolean getSheared() {
+		return (this.dataWatcher.getWatchableObjectByte(16) & 16) != 0;
+	}
+
+	public void setSheared(boolean var1) {
+		byte var2 = this.dataWatcher.getWatchableObjectByte(16);
+		if(var1) {
+			this.dataWatcher.updateObject(16, Byte.valueOf((byte)(var2 | 16)));
+		} else {
+			this.dataWatcher.updateObject(16, Byte.valueOf((byte)(var2 & -17)));
+		}
+
 	}
 }
--- /dev/null
+++ net/minecraft/src/Packet105UpdateProgressbar.java
@@ -1,0 +1,31 @@
+package net.minecraft.src;
+
+import java.io.DataInputStream;
+import java.io.DataOutputStream;
+import java.io.IOException;
+
+public class Packet105UpdateProgressbar extends Packet {
+	public int windowId;
+	public int progressBar;
+	public int progressBarValue;
+
+	public void processPacket(NetHandler var1) {
+		var1.func_20090_a(this);
+	}
+
+	public void readPacketData(DataInputStream var1) throws IOException {
+		this.windowId = var1.readByte();
+		this.progressBar = var1.readShort();
+		this.progressBarValue = var1.readShort();
+	}
+
+	public void writePacketData(DataOutputStream var1) throws IOException {
+		var1.writeByte(this.windowId);
+		var1.writeShort(this.progressBar);
+		var1.writeShort(this.progressBarValue);
+	}
+
+	public int getPacketSize() {
+		return 5;
+	}
+}
--- /dev/null
+++ net/minecraft/src/Packet102WindowClick.java
@@ -1,0 +1,67 @@
+package net.minecraft.src;
+
+import java.io.DataInputStream;
+import java.io.DataOutputStream;
+import java.io.IOException;
+
+public class Packet102WindowClick extends Packet {
+	public int window_Id;
+	public int inventorySlot;
+	public int mouseClick;
+	public short action;
+	public ItemStack itemStack;
+	public boolean field_27050_f;
+
+	public Packet102WindowClick() {
+	}
+
+	public Packet102WindowClick(int var1, int var2, int var3, boolean var4, ItemStack var5, short var6) {
+		this.window_Id = var1;
+		this.inventorySlot = var2;
+		this.mouseClick = var3;
+		this.itemStack = var5;
+		this.action = var6;
+		this.field_27050_f = var4;
+	}
+
+	public void processPacket(NetHandler var1) {
+		var1.func_20091_a(this);
+	}
+
+	public void readPacketData(DataInputStream var1) throws IOException {
+		this.window_Id = var1.readByte();
+		this.inventorySlot = var1.readShort();
+		this.mouseClick = var1.readByte();
+		this.action = var1.readShort();
+		this.field_27050_f = var1.readBoolean();
+		short var2 = var1.readShort();
+		if(var2 >= 0) {
+			byte var3 = var1.readByte();
+			short var4 = var1.readShort();
+			this.itemStack = new ItemStack(var2, var3, var4);
+		} else {
+			this.itemStack = null;
+		}
+
+	}
+
+	public void writePacketData(DataOutputStream var1) throws IOException {
+		var1.writeByte(this.window_Id);
+		var1.writeShort(this.inventorySlot);
+		var1.writeByte(this.mouseClick);
+		var1.writeShort(this.action);
+		var1.writeBoolean(this.field_27050_f);
+		if(this.itemStack == null) {
+			var1.writeShort(-1);
+		} else {
+			var1.writeShort(this.itemStack.itemID);
+			var1.writeByte(this.itemStack.stackSize);
+			var1.writeShort(this.itemStack.getItemDamage());
+		}
+
+	}
+
+	public int getPacketSize() {
+		return 11;
+	}
+}
--- net/minecraft/src/BlockButton.java
+++ net/minecraft/src/BlockButton.java
@@ -132,6 +132,9 @@
 	}
 
 	public boolean blockActivated(World var1, int var2, int var3, int var4, EntityPlayer var5) {
+		if (var1.multiplayerWorld) {
+			return true;
+		}
 		int var6 = var1.getBlockMetadata(var2, var3, var4);
 		int var7 = var6 & 7;
 		int var8 = 8 - (var6 & 8);
@@ -141,6 +144,7 @@
 			var1.setBlockMetadataWithNotify(var2, var3, var4, var7 + var8);
 			var1.markBlocksDirty(var2, var3, var4, var2, var3, var4);
 			var1.playSoundEffect((double)var2 + 0.5D, (double)var3 + 0.5D, (double)var4 + 0.5D, "random.click", 0.3F, 0.6F);
+			
 			var1.notifyBlocksOfNeighborChange(var2, var3, var4, this.blockID);
 			if(var7 == 1) {
 				var1.notifyBlocksOfNeighborChange(var2 - 1, var3, var4, this.blockID);
@@ -199,6 +203,9 @@
 	}
 
 	public void updateTick(World var1, int var2, int var3, int var4, Random var5) {
+		if(var1.multiplayerWorld)
+			return;
+		
 		int var6 = var1.getBlockMetadata(var2, var3, var4);
 		if((var6 & 8) != 0) {
 			var1.setBlockMetadataWithNotify(var2, var3, var4, var6 & 7);
--- net/minecraft/src/BlockTNT.java
+++ net/minecraft/src/BlockTNT.java
@@ -24,12 +24,18 @@
 	}
 
 	public void onBlockDestroyedByExplosion(World var1, int var2, int var3, int var4) {
+		if(var1.multiplayerWorld)
+			return;
+		
 		EntityTNTPrimed var5 = new EntityTNTPrimed(var1, (float)var2 + 0.5F, (float)var3 + 0.5F, (float)var4 + 0.5F);
 		var5.fuse = var1.rand.nextInt(var5.fuse / 4) + var5.fuse / 8;
 		var1.spawnEntityInWorld(var5);
 	}
 
 	public void onBlockDestroyedByPlayer(World var1, int var2, int var3, int var4, int var5) {
+		if(var1.multiplayerWorld)
+			return;
+		
 		EntityTNTPrimed var6 = new EntityTNTPrimed(var1, (float)var2 + 0.5F, (float)var3 + 0.5F, (float)var4 + 0.5F);
 		var1.spawnEntityInWorld(var6);
 		var1.playSoundAtEntity(var6, "random.fuse", 1.0F, 1.0F);
--- /dev/null
+++ net/minecraft/src/ThreadCloseConnection.java
@@ -1,0 +1,22 @@
+package net.minecraft.src;
+
+class ThreadCloseConnection extends Thread {
+	final NetworkManager field_28109_a;
+
+	ThreadCloseConnection(NetworkManager var1) {
+		this.field_28109_a = var1;
+	}
+
+	public void run() {
+		try {
+			Thread.sleep(2000L);
+			if(NetworkManager.isRunning(this.field_28109_a)) {
+				NetworkManager.getWriteThread(this.field_28109_a).interrupt();
+				this.field_28109_a.networkShutdown("Connection closed", new Object[0]);
+			}
+		} catch (Exception var2) {
+			var2.printStackTrace();
+		}
+
+	}
+}
--- /dev/null
+++ net/minecraft/src/Packet25EntityPainting.java
@@ -1,0 +1,52 @@
+package net.minecraft.src;
+
+import java.io.DataInputStream;
+import java.io.DataOutputStream;
+import java.io.IOException;
+
+public class Packet25EntityPainting extends Packet {
+	public int entityId;
+	public int xPosition;
+	public int yPosition;
+	public int zPosition;
+	public int direction;
+	public String title;
+
+	public Packet25EntityPainting() {
+	}
+
+	public Packet25EntityPainting(EntityPainting var1) {
+		this.entityId = var1.entityID;
+		this.xPosition = var1.xPosition;
+		this.yPosition = var1.yPosition;
+		this.zPosition = var1.zPosition;
+		this.direction = var1.direction;
+		this.title = var1.art.title;
+	}
+
+	public void readPacketData(DataInputStream var1) throws IOException {
+		this.entityId = var1.readInt();
+		this.title = readString(var1, EnumArt.maxArtTitleLength);
+		this.xPosition = var1.readInt();
+		this.yPosition = var1.readInt();
+		this.zPosition = var1.readInt();
+		this.direction = var1.readInt();
+	}
+
+	public void writePacketData(DataOutputStream var1) throws IOException {
+		var1.writeInt(this.entityId);
+		writeString(this.title, var1);
+		var1.writeInt(this.xPosition);
+		var1.writeInt(this.yPosition);
+		var1.writeInt(this.zPosition);
+		var1.writeInt(this.direction);
+	}
+
+	public void processPacket(NetHandler var1) {
+		var1.func_21146_a(this);
+	}
+
+	public int getPacketSize() {
+		return 24;
+	}
+}
--- /dev/null
+++ net/minecraft/src/Empty1.java
@@ -1,0 +1,4 @@
+package net.minecraft.src;
+
+class Empty1 {
+}
--- net/minecraft/src/EntityTNTPrimed.java
+++ net/minecraft/src/EntityTNTPrimed.java
@@ -11,18 +11,21 @@
 		this.yOffset = this.height / 2.0F;
 	}
 
-	public EntityTNTPrimed(World var1, float var2, float var3, float var4) {
+	public EntityTNTPrimed(World var1, double var2, double var3, double var4) {
 		this(var1);
-		this.setPosition((double)var2, (double)var3, (double)var4);
+		this.setPosition(var2, var3, var4);
 		float var5 = (float)(Math.random() * (double)((float)Math.PI) * 2.0D);
 		this.motionX = (double)(-MathHelper.sin(var5 * (float)Math.PI / 180.0F) * 0.02F);
 		this.motionY = (double)0.2F;
 		this.motionZ = (double)(-MathHelper.cos(var5 * (float)Math.PI / 180.0F) * 0.02F);
 		this.canTriggerWalking = false;
 		this.fuse = 80;
-		this.prevPosX = (double)var2;
-		this.prevPosY = (double)var3;
-		this.prevPosZ = (double)var4;
+		this.prevPosX = var2;
+		this.prevPosY = var3;
+		this.prevPosZ = var4;
+	}
+
+	protected void entityInit() {
 	}
 
 	public boolean canBeCollidedWith() {
